/*********************************/
/* Sweep Library Header File     */
/* Copyright (c) 1990 Eric Tauck */
/* All Rights Reserved           */
/*********************************/

#ifndef __SWEEP__
#define __SWEEP__

#define SWEEP_NULL 0
#define SWEEP_NOERROR 0
#define SWEEP_OUTOFMEMORY 1
#define SWEEP_OUTOFBLOCKS 2

typedef unsigned HeapHandle;

#ifdef __cplusplus
extern "C" {
#endif

#ifdef __HUGE__
#define _huge huge
#else
#define _huge far
#endif

void _huge * pascal far PointerNormal (void _huge *p);
void far * pascal far PointerDenormal (void _huge *p);
void _huge * pascal far PointerAdd (void _huge *p, unsigned long o);
void _huge * pascal far PointerSub (void _huge *p, unsigned long o);
unsigned long pascal far PointerValue (void _huge *p);
unsigned long pascal far PointerDiff (void _huge *p1, void _huge *p2);

void _huge * pascal far CopyForward (void _huge *d, void _huge *s, unsigned long c);
void _huge * pascal far CopyBackward (void _huge *d, void _huge *s, unsigned long c);
void _huge * pascal far CopyBlock (void _huge *d, void _huge *s, unsigned long c);

void _huge * pascal far HeapInit (void _huge *h, unsigned long s);
void _huge * pascal far HeapInitBlk (void _huge *h, unsigned long s, unsigned b);
void _huge * pascal far HeapShrink (unsigned long s);
void _huge * pascal far HeapExpand (unsigned long s);
void _huge * pascal far HeapReloc (void _huge *h);
void _huge * pascal far HeapCurrent (void);
void _huge * pascal far HeapSelect (void _huge *h);

unsigned long pascal far HeapMemory (void);
unsigned pascal far HeapBlocks (void);

HeapHandle pascal far HeapAlloc (unsigned long s);
HeapHandle pascal far HeapResize (HeapHandle b, unsigned long s);
void pascal far HeapFree (HeapHandle b);
unsigned long pascal far HeapSize (HeapHandle b);
void _huge * pascal far HeapAddr (HeapHandle b);

int pascal far HeapResult (void);

#ifdef __cplusplus
}
#endif

#endif
